package de.ifgi.unimuenster;

import java.util.List;

import de.ifgi.unimuenster.exceptions.DataSourceException;
import de.ifgi.unimuenster.model.DataSources;
import de.ifgi.unimuenster.model.impl.BoundingBox;
import de.ifgi.unimuenster.model.impl.Latitude;
import de.ifgi.unimuenster.model.impl.Longitude;
import de.noiseserver.dto.MeasureSingleDto;

/**
 * This is a simple example for demonstration purpose.
 * 
 * @author steffan
 * 
 */
public class Demo {

	/**
	 * @param args
	 * @throws DataSourceException
	 */
	public static void main(String[] args) throws DataSourceException {

		// create the bounding box
		BoundingBox b = new BoundingBox(new Longitude(-75.0), new Longitude(
				-60.20), new Latitude(50.5), new Latitude(40.2));

		// make the requst
		List<MeasureSingleDto> result = DataSource.INSTANCE.getMeasurements(b,
				null, DataSources.NOISETUBE);

		// iterate over the result
		for (MeasureSingleDto current : result) {

			// print out the result
			System.out.println(current.getNoise() + " lat: "
					+ current.getLocationMeasure().getLatitude() + " lng: "
					+ current.getLocationMeasure().getLongitude());
		}

	}

}
