/**
 * 
 */
package de.ifgi.unimuenster.model;

/**
 * Describes a measurement.
 * 
 * @author steffan
 *
 */
public interface Measurement {
	
	/**
	 * Returns a string representation of the latitude.
	 * @return the latitude as string
	 */
	public String getLat();

	/**
	 * Sets the latitude.
	 * @param lat latitude to set
	 */
	public void setLat(String lat);

	/**
	 * Returns a string representation of the longitude.
	 * @return the longitude as string
	 */
	public String getLng();

	/**
	 * Sets the longitude.
	 * @param lng longitude to set
	 */
	public void setLng(String lng);
	
	/**
	 * Returns the {@link Latitude}.
	 * @return the {@link Latitude}
	 */
	public Latitude getLatitude();
	
	/**
	 * Returns the {@link Longitude}.
	 * @return the {@link Longitude}
	 */
	public Longitude getLongitude();
	
	/**
	 * Returns the loudness.
	 * @return the loudness
	 */
	public int getLoudness();

	/**
	 * Sets the loudness.
	 * @param loudness the loudness to set
	 */
	public void setLoudness(int loudness);
	
	/**
	 * Returns the NoiseTube date string.
	 * @return the NoiseTube data string.
	 */
	public String getMade_at();

	/**
	 * Sets the NoiseTube data string
	 * @param madeAt NoiseTube data string to set
	 */
	public void setMade_at(String madeAt);

}
