package de.ifgi.unimuenster.model.impl;

import de.ifgi.unimuenster.model.Latitude;
import de.ifgi.unimuenster.model.Longitude;

/**
 * The measurement implementation. The methods have to fit the JSON format.
 * @author umut
 * @author steffan
 * 
 */
public class Measurement implements de.ifgi.unimuenster.model.Measurement {

	private String user;
	private String lat;
	private String lng;
	private String made_at;
	private int loudness;

	public Measurement() {
	}

	public String getUser() {
		return user;
	}

	public void setUser(String user) {

		this.user = user;
	}

	public String getLat() {
		return lat;
	}

	public void setLat(String lat) {
		this.lat = lat;
	}

	public String getLng() {
		return lng;
	}

	public void setLng(String lng) {
		this.lng = lng;
	}

	public String getMade_at() {
		return made_at;
	}

	public void setMade_at(String madeAt) {
		made_at = madeAt;
	}

	public int getLoudness() {
		return loudness;
	}

	public void setLoudness(int loudness) {
		this.loudness = loudness;
	}

	@Override
	public Latitude getLatitude() {

		double x;

		try {
			x = Double.valueOf(this.lat);
		} catch (Exception e) {
			return null;
		}

		return new de.ifgi.unimuenster.model.impl.Latitude(x);
	}

	@Override
	public Longitude getLongitude() {

		double x;
		try {
			x = Double.valueOf(this.lng);
		} catch (Exception e) {

			return null;
		}

		return new de.ifgi.unimuenster.model.impl.Longitude(x);
	}

	@Override
	public String toString() {
		return lat + " - " + lng + " - " + made_at + " - " + loudness;
	}

}
