package de.noisedroid.activities;

import java.util.List;

import android.os.Bundle;
import android.widget.RelativeLayout;

import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;

import de.noisedroid.R;
import de.noisedroid.osm.TileOverlay;


/**
 * Basisklasse fr viele kartenbesierte Activities.
 * 
 */

public class BasicMapActivity extends MapActivity {
	protected MapView mapView;
	protected MapController mapController;
	protected MyLocationOverlay myLocOverlay;
	protected TileOverlay tileOverlay;
	protected List<Overlay> mapOverlays;
	protected RelativeLayout mainLayout;

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.mapview);

		mainLayout = (RelativeLayout) findViewById(R.id.layout);
		mapView = (MapView) findViewById(R.id.mapView);

		// minimap.setVisibility(View.GONE);

		mapView.setBuiltInZoomControls(true);
		mapController = mapView.getController();
		mapOverlays = mapView.getOverlays();
		tileOverlay = new TileOverlay();
		mapOverlays.add(0, tileOverlay);

		myLocOverlay = new MyLocationOverlay(this, mapView);
		mapOverlays.add(myLocOverlay);
		mapView.invalidate();
	}

	/**
	 * Holt den eigenen Standort aus dem myLocOverlay und verschiebt Kartenansicht dorthin
	 */

	public void showOwnLocation() {
		if (!myLocOverlay.isMyLocationEnabled()) {
			// My Location anzeigen
			myLocOverlay.enableMyLocation();
			myLocOverlay.enableCompass();

			myLocOverlay.runOnFirstFix(new Runnable() {
				public void run() {
					mapController.animateTo(myLocOverlay.getMyLocation());
				}
			});

			mapController.setZoom(18);
		} else
			// My Location wieder verbergen
			myLocOverlay.disableMyLocation();
		myLocOverlay.disableCompass();

	}

	@Override
	protected void onPause() {
		super.onPause();
		// Listener fr Location und Kompass wieder deaktivieren
		myLocOverlay.disableMyLocation();
		myLocOverlay.disableCompass();
	}

}
