package de.noisedroid.activities;

import de.noisedroid.R;
import de.noisedroid.R.string;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.SpannableString;
import android.text.method.LinkMovementMethod;
import android.text.util.Linkify;
import android.view.ViewGroup.LayoutParams;
import android.widget.TextView;

public class EndUserLisenceAgreement {

	private String EULA_PREFIX = "eula_";
	private Activity mActivity;
	private boolean showAsInformation = false;

	public EndUserLisenceAgreement(Activity context) {
		mActivity = context;
	}

	public EndUserLisenceAgreement(Activity context, boolean showAsInformation) {
		mActivity = context;
		this.showAsInformation = true;
	}

	public void show() {
		PackageInfo pi = null;
		try {
			pi = mActivity.getPackageManager()
					.getPackageInfo(mActivity.getPackageName(), PackageManager.GET_ACTIVITIES);
		} catch (NameNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		final String eulaKey = EULA_PREFIX + pi.versionCode;
		final SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(mActivity);
		boolean hasBeenShown = prefs.getBoolean(eulaKey, false);
		if (showAsInformation | hasBeenShown == false) {

			String title = mActivity.getString(R.string.app_name) + " v" + pi.versionName;

			final TextView message = new TextView(mActivity);

			final SpannableString s = new SpannableString(mActivity.getText(R.string.eula));

			Linkify.addLinks(s, Linkify.WEB_URLS);
			message.setText(s);
			message.setMovementMethod(LinkMovementMethod.getInstance());
			AlertDialog.Builder builder = null;
			if (showAsInformation == false) {
				builder = new AlertDialog.Builder(mActivity).setTitle(title).setView(message)
						.setPositiveButton(android.R.string.ok, new Dialog.OnClickListener() {

							public void onClick(DialogInterface dialogInterface, int i) {
								// Mark this version as read.
								SharedPreferences.Editor editor = prefs.edit();
								editor.putBoolean(eulaKey, true);
								editor.commit();
								dialogInterface.dismiss();
							}
						}).setNegativeButton(android.R.string.cancel, new Dialog.OnClickListener() {

							public void onClick(DialogInterface dialog, int which) {
								mActivity.finish();
							}

						});
			} else {
				builder = new AlertDialog.Builder(mActivity).setTitle(title).setView(message).setCancelable(false)
						.setPositiveButton(android.R.string.ok, new Dialog.OnClickListener() {

							public void onClick(DialogInterface dialogInterface, int i) {
								// Mark this version as read.
								SharedPreferences.Editor editor = prefs.edit();
								editor.putBoolean(eulaKey, true);
								editor.commit();
								dialogInterface.dismiss();
							}
						});
			}
			builder.create().show();
		}
	}

}