package de.noisedroid.activities;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.webkit.WebView;
import android.widget.ViewAnimator;
import de.noisedroid.R;

/**
 * Activity fr die kontextabhngige Hilfe. Mittels Intent wird der gewnschte Hilfeinhalt angezeigt
 * 
 */
public class HelpActivity extends Activity {
	public static final int MANUAL_MEASURE = 1;
	public static final int LIST = 2;
	public static final int MAP = 3;
	public static final int SERIES = 4;
	public static final int SETTINGS = 5;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.help);
		WebView webview = (WebView) findViewById(R.id.WebView);
		webview.setBackgroundColor(Color.TRANSPARENT);

		String content = "";
		switch (getIntent().getIntExtra("helpId", 0)) {
		case MANUAL_MEASURE:
			content = getString(R.string.help_measure);
			break;
		case LIST:
			content = getString(R.string.help_list);
			break;
		case MAP:
			content = getString(R.string.help_map);
			break;
		case SERIES:
			content = getString(R.string.help_series);
			break;
		case SETTINGS:
			content = getString(R.string.help_settings);
			break;
		default:
			content = getString(R.string.unbekannter_fehler);
		}

		webview.loadDataWithBaseURL("file://egal",
				"<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\"/><body style=\"color:white;\">"
						+ content + "</body>", null, "utf-8", null);

	}

}
