package de.noisedroid.activities;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import de.noisedroid.R;
import de.noisedroid.community.AccountManager;
import de.noisedroid.community.RegistrationRequest;
import de.noisedroid.community.Request.Error;
import de.noisedroid.community.ResetPasswordRequest;
import de.noisedroid.community.ServerRequest;
import de.noiseserver.Commons;


public class ResetPasswordActivity extends Activity {
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.resetpassword);

		final EditText usernameText = (EditText) findViewById(R.id.EditTextUsername);
		final EditText emailText = (EditText) findViewById(R.id.EditTextEmail);

		Button okButton = (Button) findViewById(R.id.ButtonOK);
		okButton.setOnClickListener(new View.OnClickListener() {

			public void onClick(View v) {
				String username = usernameText.getText().toString();
				String mail = emailText.getText().toString();
				
				ServerRequest request = new ServerRequest();
				ResetPasswordRequest resetPasswordRequest = new ResetPasswordRequest(username, mail);
					request.addRequest(resetPasswordRequest);
					request.postRequest();

				// Serverantwort
				if (resetPasswordRequest.getErrors().isEmpty()) {
					// Erfolg
					new AlertDialog.Builder(ResetPasswordActivity.this).setCancelable(false)
							.setTitle(R.string.resetpassword_erfolgreich_info)
							.setMessage(R.string.resetpassword_erfolgreich)
							.setPositiveButton(R.string.ok, new OnClickListener() {
								public void onClick(DialogInterface dialog, int which) {
									finish();
								}
							}).create().show();

				} else if (resetPasswordRequest.getErrors().contains(Error.ConnectionError)) {
					// Verbindungsfehler
					new AlertDialog.Builder(ResetPasswordActivity.this).setTitle(R.string.reset_password_failed)
							.setMessage(R.string.verbindungsfehler).setPositiveButton(R.string.ok, null).create()
							.show();
				} else {
					// TODO Genaue Fehlerquellen ausmachen...
					// TODO Wrong error message!!
					new AlertDialog.Builder(ResetPasswordActivity.this).setTitle(R.string.reset_password_failed)
							.setMessage(R.string.reset_password_failed).setPositiveButton(R.string.ok, null)
							.create().show();
				}

			}
		});
		Button cancelButton = (Button) findViewById(R.id.ButtonAbbrechen);
		cancelButton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				finish();
			}
		});
	}
}
