package de.noisedroid.activities.measurelist;

import android.view.ContextMenu;
import de.noisedroid.activities.measurelist.gruppierer.Gruppierer;
import de.noisedroid.measure.MeasureAbstract;

public interface ListProvider<GenGruppierer extends Gruppierer> {
	
	public interface OnMeasureSelectedListener {
		public void onMeasureSelected(MeasureAbstract measure);
	}

	public interface OnCreateMeasureContextMenuListener {
		public void onCreateContextMenu(ContextMenu menu, MeasureAbstract measure);
	}

	public interface OnProgressUpdateListener {
		public void onProgressUpdate(int waitingProcesses);
	}

	public abstract void setOnMeasureSelectedListener(OnMeasureSelectedListener listener);

	public abstract void setOnCreateMeasureContextMenuListener(OnCreateMeasureContextMenuListener listener);

	public abstract void reload();

	public abstract void setGruppierer(GenGruppierer gruppierer);

	public abstract void setSortierer(DownloadComparator sortierer);

}
