package de.noisedroid.activities.measurelist.adapter;

import java.util.Collections;
import java.util.Comparator;

import android.content.Context;
import de.noisedroid.activities.measurelist.gruppierer.LocalGruppierer;
import de.noisedroid.measure.MeasureAbstract;

/**
 * Stellt Gruppe innerhalb der Liste dar. Ist fr die eigentliche Darstellung der Messungen verantwortlich
 * 
 */
public class MeasureGroup extends BaseMeasureGroup<LocalGruppierer> {

	public MeasureGroup(int id, Context context, BaseMeasureExpandableListAdapter<?, LocalGruppierer> parentAdapter) {
		super(id, context, parentAdapter);
	}

	public void addMeasure(MeasureAbstract measure, Comparator<MeasureAbstract> comparator) {
		int index = Collections.binarySearch(measureList, measure, comparator);
		if (index < 0) {
			measureList.add(-index - 1, measure);
		} else {
			measureList.add(index, measure);
		}
	}

	public void reorderMeasures(Comparator<MeasureAbstract> comparator) {
		Collections.sort(measureList, comparator);
	}

	public void removeMeasure(MeasureAbstract measure) {
		measureList.remove(measure);
	}

	public void clear() {
		measureList.clear();
	}

}
