package de.noisedroid.activities.measurelist.gruppierer;

import de.noisedroid.activities.measurelist.DownloadComparator;
import de.noisedroid.community.DownloadFilter;
import de.noisedroid.measure.MeasureAbstract;
import de.noiseserver.Commons.OrderAttr;
import de.noiseserver.Commons.OrderDir;

/**
 * Gruppierung nach Lärmwert
 * 
 */
public class NoiseGruppierer implements LocalGruppierer, DownloadGruppierer, DownloadComparator {
	public int compare(MeasureAbstract object1, MeasureAbstract object2) {
		return Double.compare(object1.getNoise(), object2.getNoise());
	}

	public int getGroupIndex(MeasureAbstract measure) {
		float noise = measure.getNoise();

		if (noise > 80)
			return 3;
		else if (noise > 60)
			return 2;
		else if (noise > 40)
			return 1;
		else
			return 0;
	}

	public String getGroupTitle(int index) {
		switch (index) {
		case 0:
			return "< 40 dB";
		case 1:
			return "> 40 dB";
		case 2:
			return "> 60 dB";
		case 3:
			return "> 80 dB";
		}
		return null;
	}

	public DownloadFilter getGroupFilter(int index) {
		DownloadFilter filter = new DownloadFilter();
		switch (index) {
		case 0:
			filter.noiseBis = 40f;
			break;
		case 1:
			filter.noiseVon = 40f;
			filter.noiseBis = 60f;
			break;
		case 2:
			filter.noiseVon = 60f;
			filter.noiseBis = 80f;
			break;
		case 3:
			filter.noiseVon = 80f;
			break;
		}
		return filter;
	}

	public int getGroupCount() {
		return 4;
	}

	public OrderAttr getOrderAttr() {
		return OrderAttr.NOISE;
	}

	public OrderDir getOrderDir() {
		return OrderDir.ASC;
	}

}
