package de.noisedroid.activities.measurelist.gruppierer;

import android.content.Context;
import de.noisedroid.R;
import de.noisedroid.measure.MeasureAbstract;

/**
 * Gruppierung nach Hochladestatus
 * 
 */
public class UploadGruppierer implements LocalGruppierer {
	private Context ctx;
	public UploadGruppierer(Context ctx){
		this.ctx=ctx;
	}
	public int getGroupIndex(MeasureAbstract measure) {
		if (measure.isCommunity()) {
			return 3;
		} else {
			switch (measure.getUploadStatus()) {
			case NotUploaded:
			case UploadFailed:
			case NeMischung:
				return 0;
			case Uploaded:
				return 1;
			case UploadRejected:
				return 2;
			default:
				return 0;
			}
		}
	}

	public String getGroupTitle(int index) {
		switch (index) {
		case 0:
			return ctx.getString(R.string.nicht_hochgeladen);
		case 1:
			return ctx.getString(R.string.erfolgreich_hochgeladen);
		case 2:
			return ctx.getString(R.string.hochladen_verweigert);
		case 3:
			return ctx.getString(R.string.andere);
		}
		return null;
	}

	public int getGroupCount() {
		return 4;
	}

}
