package de.noisedroid.activities.util;

import android.content.Context;
import android.content.Intent;
import android.graphics.Rect;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.RelativeLayout.LayoutParams;
import android.widget.Toast;
import de.noisedroid.R;
import de.noisedroid.activities.BasicMapActivity;
import de.noisedroid.util.SelectRectOverlay;

/**
 * Activity zum Auswhlen einer Bounding Box. Rckgabe des Ergebnisses via Intent
 *
 */
public class SelectRectActivity extends BasicMapActivity {

	private SelectRectOverlay selectOverlay;
	private View panel; 

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		LayoutInflater inflater = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		panel = inflater.inflate(R.layout.osmdownload_panel, null);
		LayoutParams params = new RelativeLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT);
		params.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
		mainLayout.addView(panel, params);
		
		selectOverlay = new SelectRectOverlay();
		Rect selectRectE6 = getIntent().getParcelableExtra("rectE6");
		if (selectRectE6 != null) {
			selectOverlay.setSelectionRect(selectRectE6);
		}

		Button okButton = (Button) panel.findViewById(R.id.OKButton);
		okButton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				Bundle antwortBundle = new Bundle();

				antwortBundle.putParcelable("rectE6", selectOverlay.getSelectionRect());
				Intent antwortIntent = new Intent();
				antwortIntent.putExtras(antwortBundle);

				setResult(RESULT_OK, antwortIntent);
				finish();
			}
		});

		Button auswahlButton = (Button) panel.findViewById(R.id.AuswahlButton);
		auswahlButton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				selectOverlay.restRect();
				Toast.makeText(SelectRectActivity.this, R.string.ziehen_sie_ein_auswahlrechteck_ber_die_karte,
						Toast.LENGTH_LONG).show();
			}
		});

		mapOverlays.add(selectOverlay); 
		
		mapView.setBuiltInZoomControls(false);

		LinearLayout zoomLayout = (LinearLayout) findViewById(R.id.layout_zoom);
		@SuppressWarnings("deprecation")
		View zoomView = mapView.getZoomControls();

		zoomLayout.addView(zoomView,
				new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
		mapView.displayZoomControls(true);
		
	}

}
