package de.noisedroid.community;

import java.util.concurrent.atomic.AtomicBoolean;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlSerializer;

import de.noisedroid.util.Util;
import de.noiseserver.Commons;

public class DeleteAccountRequest extends Request {
	private String username;
	private String password;

	@Override
	public String getType() {
		return Commons.REQUEST_TYPE_DELETE_USER;
	}

	@Override
	public void serializeAttributes(XmlSerializer serializer) throws RequestException {
		try {
			serializer.startTag(null, "Username");
			serializer.attribute(null, "value", username);
			serializer.endTag(null, "Username");

			serializer.startTag(null, "Password");
			serializer.attribute(null, "value", password);
			serializer.endTag(null, "Password");

		} catch (Exception e) {
			throw new RequestException(e.getMessage());
		}
	}

	public DeleteAccountRequest(String username, String password) {
		this.username = username;
		this.password = password;
	}

	@Override
	public void processResponse(XmlPullParser parser) throws RequestException {
		super.processResponse(parser);

		try {
			final AtomicBoolean success = new AtomicBoolean();

			Util.forEachChild(parser, new TagFunction() {
				public void processTag(XmlPullParser parser) throws Exception {
					if (parser.getName().equalsIgnoreCase(Commons.NODE_ERROR)) {
			
							errorSet.add(Error.Unknown);
					} else if (parser.getName().equalsIgnoreCase(Commons.NODE_SUCCESS)) {
						success.set(true);
					}
				}
			});

			if (success.get() == false) {
				errorSet.add(Error.Unknown);
			}
		} catch (Exception e) {
			throw new RequestException(e.getMessage());
		}
	}
}
