package de.noisedroid.community;

import java.util.concurrent.atomic.AtomicBoolean;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlSerializer;

import de.noisedroid.util.Util;
import de.noiseserver.Commons;

/**
 * Beschreibt die Registrierungsanfrage
 *
 */
public class RegistrationRequest extends Request {
	private String passwordMD5;
	private String username;
	private String email;

	@Override
	public String getType() {
		return Commons.REQUEST_TYPE_REGISTER;
	}

	@Override
	public void serializeAttributes(XmlSerializer serializer) throws RequestException {
		try {
			serializer.startTag(null, "Username");
			serializer.attribute(null, "value", username);
			serializer.endTag(null, "Username");

			serializer.startTag(null, "Password");
			serializer.attribute(null, "value", passwordMD5);
			serializer.endTag(null, "Password");

			serializer.startTag(null, "Email");
			serializer.attribute(null, "value", email);
			serializer.endTag(null, "Email");

		} catch (Exception e) {
			throw new RequestException(e.getMessage());
		}
	}

	public RegistrationRequest(String username, String passwordMD5, String email) {
		this.username = username;
		this.passwordMD5 = passwordMD5;
		this.email = email;
	}

	@Override
	public void processResponse(XmlPullParser parser) throws RequestException {
		super.processResponse(parser);

		try {
			final AtomicBoolean success = new AtomicBoolean();

			Util.forEachChild(parser, new TagFunction() {
				public void processTag(XmlPullParser parser) throws Exception {
					if (parser.getName().equalsIgnoreCase(Commons.NODE_ERROR)) {
						// TODO Verschiedene Fehler unterscheiden
						//String type = parser.getAttributeValue(null, "type");
						//if (type == null) {
						// errorSet.add(Error.Unknown);
						// } else {
						// if(type.equalsIgnoreCase("...")) {
						//
						// }
						// }
						errorSet.add(Error.Unknown);
					} else if (parser.getName().equalsIgnoreCase(Commons.NODE_SUCCESS)) {
						success.set(true);
					}
				}
			});

			if (success.get() == false) {
				errorSet.add(Error.Unknown);
			} else {
				AccountManager.setNotLoggedIn();
			}
		} catch (Exception e) {
			throw new RequestException(e.getMessage());
		}
	}

}
