package de.noisedroid.community;

import java.util.ArrayList;
import java.util.List;

import org.xmlpull.v1.XmlSerializer;

import de.noisedroid.measure.MeasureSeriesExtract;
import de.noisedroid.measure.XMLSerializable;
import de.noiseserver.Commons;

/**
 * Anfrage einer bereits hochgeladenen Serieweitere Messungen zuzufgen
 * 
 */
public class UpdateSeriesRequest extends AddMeasuresRequest {
	private List<MeasureSeriesExtract> extractList;

	public UpdateSeriesRequest(List<MeasureSeriesExtract> extractList) {
		this.extractList = extractList;
	}

	@Override
	public List<XMLSerializable> getMeasureList() {
		return new ArrayList<XMLSerializable>(extractList);
	}

	@Override
	public String getType() {
		return Commons.REQUEST_TYPE_UPDATESERIES;
	}

	@Override
	public void serializeAttributes(XmlSerializer serializer) throws RequestException {
		try {
			// serializer.startTag(null, "Measures");
			for (MeasureSeriesExtract m : extractList) {
				m.asXML(serializer, true, true);
			}
			// serializer.endTag(null, "Measures");
		} catch (Exception e) {
			throw new RequestException(e.getMessage());
		}
	}
}
