package de.noisedroid.measure;

import de.noisedroid.measure.MeasureManager.ChangeType;
import de.noisedroid.measure.MeasureManager.MeasuresChangedListener;

/**
 * Interface, welches zu implementieren ist wenn Serienmessungen aggregiert werden
 * Stellt auf einfache Weise Datenintegritt sicher.
 */
public interface MeasureParentSeries {
	/**
	 * Die Messung hat via {@link MeasureAutomatic#setMeasureParent(MeasureParentSingle)} ber den Datenhalter
	 * informiert zu werden.
	 * 
	 * @param measure
	 */
	public void addMeasure(MeasureSeries measure);
	public void removeMeasure(MeasureSeries measure);
	public void reportChange(ChangeType change, MeasureSeries measure);
	public void reportChange(ChangeType change, MeasureAutomatic measure);
	
	public void addChangeListener(MeasuresChangedListener listener);
	public void removeChangeListener(MeasuresChangedListener listener);
}
 