package de.noisedroid.measure;

import de.noisedroid.measure.MeasureManager.ChangeType;
import de.noisedroid.measure.MeasureManager.MeasuresChangedListener;

/**
 * Interface, welches zu implementieren ist wenn Einzelmessungen aggregiert werden Stellt auf einfache Weise
 * Datenintegritt sicher.
 */
public interface MeasureParentSingle {
	/**
	 * Die Messung hat via {@link MeasureAutomatic#setMeasureParent(MeasureParentSingle)} ber den Datenhalter
	 * informiert zu werden.
	 * 
	 * @param measure
	 */
	public void addMeasure(MeasureAutomatic measure);
	public void removeMeasure(MeasureAutomatic measure);
	public void reportChange(ChangeType type, MeasureAutomatic measure);
	
	public void addChangeListener(MeasuresChangedListener listener);
	public void removeChangeListener(MeasuresChangedListener listener);
	
	
	public MeasureAbstract findById(int id);
}
