package de.noisedroid.measure;

import java.util.ArrayList;
import java.util.List;

import org.xmlpull.v1.XmlSerializer;

import de.noisedroid.community.UpdateSeriesRequest;

/**
 * Ermglicht es einen Ausschnitt aus einer Messserie zu beschreiben, ntig z. B. fr mehr Flexibilitt beim Hochladen
 * Serialisierung schliet nur angegebene Teilmessungen ein.
 * 
 */
public class MeasureSeriesExtract implements XMLSerializable {
	List<MeasureAutomatic> extractList = new ArrayList<MeasureAutomatic>();
	MeasureSeries parentSeries;

	public MeasureSeriesExtract(MeasureSeries parentSeries, List<MeasureAutomatic> extractList) {
		this.extractList = extractList;
		this.parentSeries = parentSeries;
	}

	public MeasureSeriesExtract(MeasureSeries parentSeries) {
		this.parentSeries = parentSeries;
	}

	public void asXML(XmlSerializer serializer, boolean forServer) throws MeasureSerializerException {
		parentSeries.asXML(serializer, extractList, forServer, false);
	}

	public void addMeasure(MeasureAutomatic measure) {
		if (!extractList.contains(measure)) {
			extractList.add(measure);
		}
	}

	/**
	 * Spezielle berladung des {@link #asXML(XmlSerializer, boolean)} zwecks Durchfhrung des
	 * {@link UpdateSeriesRequest}.
	 * 
	 * @param serializer
	 * @param forServer
	 * @param forUpdate
	 * @throws MeasureSerializerException
	 */
	public void asXML(XmlSerializer serializer, boolean forServer, boolean forUpdate) throws MeasureSerializerException {
		parentSeries.asXML(serializer, extractList, forServer, forUpdate);
	}

	public void addMeasures(List<MeasureAutomatic> extractList) {
		for(MeasureAutomatic m : extractList) {
			addMeasure(m);
		}
	}
}
