package de.noisedroid.measure;

import org.xmlpull.v1.XmlSerializer;

/**
 * Interface fr Klassen die als Teil einer XML serialisiert werden sollen.
 * 
 * Ob es unntig ist? Eher nein, Klassen wie {@link MeasureSeriesExtract} knnen keine {@link MeasureAbstract} sein,
 * aber eine XML Serialisierung ist als Teil des Uploadprozesses notwendig.
 * 
 */
public interface XMLSerializable {

	public void asXML(XmlSerializer serializer, boolean forServer) throws MeasureSerializerException;

}
