package de.noisedroid.measure.messmoral;

import java.util.List;
import java.util.Vector;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Und oder oder Verknpfung
 *
 */
public class Konjunktion extends MoralLogicExpression {
	public enum KonjunktionTyp {
		AND, OR
	}

	private List<MoralLogicExpression> ausdrcke = new Vector<MoralLogicExpression>();
	private KonjunktionTyp typ;

	public Konjunktion(NodeList nodes, KonjunktionTyp typ, MessmoralManager messmoral) throws MoralException {
		this.typ = typ;
		for (int i = 0; i < nodes.getLength(); i++) {
			if (nodes.item(i).getNodeType() == Node.ELEMENT_NODE) {
				ausdrcke.add(MoralLogicExpression.getAusdruck(nodes.item(i), messmoral));
			}
		}
	}

	@Override
	public boolean auswerten() throws MoralException {
		boolean ergebnis;
		switch (typ) {
		case AND:
			ergebnis = ausdrcke.get(0).auswerten();
			for(int i = 1; i<ausdrcke.size(); i++) {
				ergebnis = ergebnis && ausdrcke.get(1).auswerten();
				if(ergebnis == false) {
					break;
				}
			}
			return ergebnis;
		case OR:
			ergebnis = ausdrcke.get(0).auswerten();
			for(int i = 1; i<ausdrcke.size(); i++) {
				ergebnis = ergebnis || ausdrcke.get(1).auswerten();
				if(ergebnis == true) {
					break;
				}
			}
			return ergebnis;
		default:
			throw new MoralException();
		}
	}

}
