package de.noisedroid.measure.messmoral;

import org.w3c.dom.Node;

import de.noisedroid.measure.messmoral.Konjunktion.KonjunktionTyp;
import de.noisedroid.measure.messmoral.Vergleich.VergleichTyp;

/**
 * Hilfsklasse zum Zusammenfassen logischer Operationen
 *
 */
public abstract class MoralLogicExpression {
	public abstract boolean auswerten() throws MoralException;
	
	public static MoralLogicExpression getAusdruck(Node node, MessmoralManager messmoral) throws MoralException {
		String typString = node.getNodeName();
		if(typString.equalsIgnoreCase("equals"))
			return new Vergleich(node.getChildNodes(), VergleichTyp.EQUALS, messmoral);
		else if(typString.equalsIgnoreCase("less"))
			return new Vergleich(node.getChildNodes(), VergleichTyp.LESS, messmoral);
		else if(typString.equalsIgnoreCase("greater"))
			return new Vergleich(node.getChildNodes(), VergleichTyp.GREATER, messmoral);
		else if(typString.equalsIgnoreCase("and"))
			return new Konjunktion(node.getChildNodes(), KonjunktionTyp.AND, messmoral);
		else if(typString.equalsIgnoreCase("or"))
			return new Konjunktion(node.getChildNodes(), KonjunktionTyp.OR, messmoral);
		else 
			throw new MoralException();
	}
}
