package de.noisedroid.measure.messmoral;

import org.w3c.dom.Node;

/**
 * Sensorwert
 * 
 */
public class Sensordata extends MoralWert {
	private String sensorName;
	private int dataIndex;
	private MessmoralManager messmoral;
	private SensordataReference<float[]> value;

	public Sensordata(Node node, MessmoralManager messmoral) {
		this.messmoral = messmoral;
		if (node.getAttributes().getNamedItem("name") != null) {
			sensorName = node.getAttributes().getNamedItem("name").getNodeValue();
		} else {
			int type = Integer.parseInt(node.getAttributes().getNamedItem("type").getNodeValue());
			sensorName = messmoral.getSensorNameByType(type);
		}
		if (sensorName != null && node.getAttributes().getNamedItem("difference") != null) {
			if (node.getAttributes().getNamedItem("difference").getNodeValue().equalsIgnoreCase("true")) {
				sensorName += " Diff";
			}
		}
		dataIndex = Integer.parseInt(node.getAttributes().getNamedItem("index").getNodeValue());
	}

	@Override
	public float auswerten() throws MoralException {
		if (sensorName != null) {
			if (value == null || !value.valid) {
				// getSensorData nur solange noch keine Sensordaten verfgbar sind, danach reprsentiert Rckgabe immer
				// die aktuellsten Daten.
				value = messmoral.getSensorData(sensorName);
			}
			return value.data[dataIndex];
		} else {
			return 0;
		}
	}

}
