package de.noisedroid.measure.messmoral;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Vergleich
 *
 */
public class Vergleich extends MoralLogicExpression {
	public enum VergleichTyp {
		LESS, EQUALS, GREATER
	}

	private MoralWert rechts;
	private MoralWert links;
	private VergleichTyp typ;

	public Vergleich(NodeList nodes, VergleichTyp typ, MessmoralManager messmoral) throws MoralException {
		this.typ = typ;
		for (int i = 0; i < nodes.getLength(); i++) {
			if (nodes.item(i).getNodeType() == Node.ELEMENT_NODE) {
				if (links == null) {
					links = MoralWert.getWert(nodes.item(i), messmoral);
				} else if (rechts == null) {
					rechts = MoralWert.getWert(nodes.item(i), messmoral);
					break;
				}
			}
		}
	}

	@Override
	public boolean auswerten() throws MoralException {
		switch (typ) {
		case EQUALS:
			return links.auswerten() == rechts.auswerten();
		case LESS:
			return links.auswerten() < rechts.auswerten();
		case GREATER:
			return links.auswerten() > rechts.auswerten();
		default:
			return false;
		}
	}

}