package de.noisedroid.util;

import android.graphics.Color;

/**
 * Klasse bietet einige Umrechnungsmethoden fr Lrm
 * 
 */
public class Noise {
	final static int colorMin = Color.GREEN;
	final static int colorMax = Color.RED;
	final static int colorNorm = Color.YELLOW;
	final static int minNoise = 35;
	final static int normNoise = 50;
	final static int maxNoise = 70;

	public static float pcmToDB(float pcm) {
		return 20 * (float) Math.log10(pcm / 1f);
	}

	public static float DBToPcm(float dB) {
		return (float) Math.pow(10, dB / 20);
	}

	public static int getColorFromNoise(float noise) {
		if (noise <= normNoise) {
			float rn = (noise - minNoise) / (normNoise - minNoise) * 1f;
			int r = (int) (Color.red(colorMin) + ((Color.red(colorNorm) - Color.red(colorMin)) * rn));
			int g = (int) (Color.green(colorMin) + ((Color.green(colorNorm) - Color.green(colorMin)) * rn));
			int b = (int) (Color.blue(colorMin) + ((Color.blue(colorNorm) - Color.blue(colorMin)) * rn));
			return Color.rgb(Math.min(r, 255), Math.min(g, 255), Math.min(b, 255));
		} else {
			float rn = (noise - normNoise) / (maxNoise - normNoise) * 1f;
			int r = (int) (Color.red(colorNorm) + ((Color.red(colorMax) - Color.red(colorNorm)) * rn));
			int g = (int) (Color.green(colorNorm) + ((Color.green(colorMax) - Color.green(colorNorm)) * rn));
			int b = (int) (Color.blue(colorNorm) + ((Color.blue(colorMax) - Color.blue(colorNorm)) * rn));
			return Color.rgb(Math.min(r, 255), Math.min(g, 255), Math.min(b, 255));
		}
	}

	public static float getDistBetweenNoise(float noise1, float noise2) {
		return (float) Math.pow(10, (noise1 - noise2) / 20);
	}

}
