package de.noisedroid.util;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.RectF;
import android.graphics.Paint.Style;
import android.util.AttributeSet;
import android.view.View;


/**
 * Zeigt Fortschritt in einem Ring an.
 *
 */
public class ProgressCircle extends View {
	
	private final Paint mPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
	private float width = 15;
	private float fortschritt;
	
	public ProgressCircle(Context context, AttributeSet attrs) {
		super(context, attrs);
		mPaint.setStrokeWidth(width);
		mPaint.setStyle(Style.STROKE);
	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		
		RectF rect = new RectF(width/2, width/2,getWidth()-width/2,getHeight()-width/2);
		mPaint.setColor(Color.GRAY);
		mPaint.setAlpha(50);
		canvas.drawArc(rect, 0, 360, false, mPaint);
		mPaint.setColor(Color.LTGRAY);
		mPaint.setAlpha(50);
		canvas.drawArc(rect, -90, fortschritt * 360f, false, mPaint);
	}
	
	public void setFortschritt(float fortschritt) {
		this.fortschritt = fortschritt;
		invalidate();
	}
	
	@Override
	protected void onSizeChanged(int w, int h, int oldw, int oldh) {
		super.onSizeChanged(w, h, oldw, oldh);
	}
	
}
