package de.noisedroid.util;

import java.util.ArrayList;
import java.util.List;

import android.R;
import android.graphics.Color;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.BaseAdapter;
import android.widget.Gallery;

public class ViewAdapter extends BaseAdapter {
	private List<View> viewList = new ArrayList<View>();

	public int getCount() {
		return viewList.size();
	}

	public Object getItem(int position) {
		return viewList.get(position);
	}

	public long getItemId(int position) {
		return position;
	}

	public int getItemViewType(int position) {
		return position;
	}

	public View getView(int position, View convertView, ViewGroup parent) {
		return viewList.get(position);
	}

	public int getViewTypeCount() {
		return viewList.size();
	}

	public boolean hasStableIds() {
		return true;
	}

	public void addView(View view) {
		view.setLayoutParams(new Gallery.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
		viewList.add(view);
		notifyDataSetChanged();
	}

	public void clear() {
		viewList.clear();
		notifyDataSetChanged();
	}

}
