package de.ifgi.unimuenster;

import java.util.List;

import de.ifgi.unimuenster.exceptions.DataSourceException;
import de.ifgi.unimuenster.model.BoundingBox;
import de.ifgi.unimuenster.model.DataSources;
import de.ifgi.unimuenster.noisetube.NoiseTube;
import de.noiseserver.dto.MeasureSingleDto;
import de.noiseserver.service.FilterRemote;

/**
 * 
 * @author steffan
 * 
 * 
 */
public enum DataSource {

	INSTANCE;

	/**
	 * Returns a list of {@link MeasureSingleDto} found inside the specified {@link BoundingBox}.
	 * 
	 * @param boundingBox 
	 * @param dataSources
	 * @return
	 * @throws DataSourceException
	 */
	public List<MeasureSingleDto> getMeasurements(BoundingBox boundingBox, FilterRemote filter,
			DataSources dataSources) throws DataSourceException {

		try {
			if (DataSources.NOISETUBE.equals(dataSources)) {

				return NoiseTube.getMeasurements(boundingBox, filter);

			}
		} catch (Exception e) {

			throw new DataSourceException(e);
		}
		return null;

	}
	
	/**
	 * 
	 * @param cityID
	 * @param dataSources
	 * @return
	 * @throws DataSourceException
	 */
	public List<MeasureSingleDto> getMeasurements(int cityID, FilterRemote filter,
			DataSources dataSources) throws DataSourceException {
		
		try {
			if (DataSources.NOISETUBE.equals(dataSources)) {

				return NoiseTube.getMeasurements(cityID, filter);

			}
		} catch (Exception e) {

			throw new DataSourceException(e);
		}
		return null;

	}
}
