/**
 * 
 */
package de.ifgi.unimuenster.noisetube;

import java.io.IOException;
import java.net.MalformedURLException;

import de.ifgi.unimuenster.model.BoundingBox;

/**
 * @author steffan
 * 
 */
public class NoiseTubeRequest {
	
	private NoiseTubeRequest(){};

	private final static String KEY = "420f3173de7efe6462822974ec07a81f292d5638";
	private final static String ADDRESS = "http://www.noisetube.net/api/search.json?";
	
	private static String injectedResult = null;
	
	public static void injectResult(String result){
		
		NoiseTubeRequest.injectedResult = result;
	}
	
	public static String getJSON(int cityID) throws MalformedURLException, IOException{
		
		if(injectedResult != null){
			
			String copy = injectedResult;
			
			injectedResult = null;
			
			return copy;
		}
		
		String request = ADDRESS + "key=" + KEY + "&city="
				+ cityID;
		
		System.out.println("REQUEST: " + request);
		
		WebFile webFile = null;
		
			webFile = new WebFile(request);
		
		
		
		Object content = webFile.getContent( );
		
		    String html = (String)content;
		    
		    return html;
	}

	public static String getJSON(BoundingBox boundingBox) throws MalformedURLException, IOException {
		
		if(injectedResult != null){
			
			String copy = injectedResult;
			
			injectedResult = null;
			
			return copy;
		}

		if (boundingBox == null)
			throw new NullPointerException("boundingBox can not be null");

		String request = ADDRESS + "key=" + KEY + "&geo="
				+ boundingBox.toString();

		
		System.out.println("REQUEST: " + request);
		
		WebFile webFile = null;
		
			webFile = new WebFile(request);
	
		
		
		Object content = webFile.getContent( );
		
		    String html = (String)content;
		    
		    return html;

	}

	/**
	 * Copied from http://nadeausoftware.com/node/73#Code
	 * @author steffan
	 *
	 */
	private static class WebFile {

		private String charset = null;
		private Object content = null;

		/** Open a web file. 
		 * @param urlString 
		 * @throws java.net.MalformedURLException 
		 * @throws java.io.IOException */
		public WebFile(String urlString) throws java.net.MalformedURLException,
				java.io.IOException {
			// Open a URL connection.
			final java.net.URL url = new java.net.URL(urlString);
			final java.net.URLConnection uconn = url.openConnection();
			if (!(uconn instanceof java.net.HttpURLConnection))
				throw new java.lang.IllegalArgumentException(
						"URL protocol must be HTTP.");
			final java.net.HttpURLConnection conn = (java.net.HttpURLConnection) uconn;

			// Set up a request.
			conn.setConnectTimeout(1000000); // 10 sec
			conn.setReadTimeout(1000000); // 10 sec
			conn.setInstanceFollowRedirects(true);
			//conn.setRequestProperty("User-agent", "spider");

			// Send the request.
			conn.connect();

			// Get the response.
			final int length = conn.getContentLength();
			final String type = conn.getContentType();
			if (type != null) {
				final String[] parts = type.split(";");
				
				for (int i = 1; i < parts.length && charset == null; i++) {
					final String t = parts[i].trim();
					final int index = t.toLowerCase().indexOf("charset=");
					if (index != -1)
						charset = t.substring(index + 8);
				}
			}

			// Get the content.
			final java.io.InputStream stream = conn.getErrorStream();
			if (stream != null)
				content = readStream(length, stream);
			else if ((content = conn.getContent()) != null
					&& content instanceof java.io.InputStream)
				content = readStream(length, (java.io.InputStream) content);
			conn.disconnect();
		}

		/** Read stream bytes and transcode. */
		private Object readStream(int length, java.io.InputStream stream)
				throws java.io.IOException {
			final int buflen = Math.max(1024,
					Math.max(length, stream.available()));
			byte[] buf = new byte[buflen];
			
			byte[] bytes = null;

			for (int nRead = stream.read(buf); nRead != -1; nRead = stream
					.read(buf)) {
				if (bytes == null) {
					bytes = buf;
					buf = new byte[buflen];
					continue;
				}
				final byte[] newBytes = new byte[bytes.length + nRead];
				System.arraycopy(bytes, 0, newBytes, 0, bytes.length);
				System.arraycopy(buf, 0, newBytes, bytes.length, nRead);
				bytes = newBytes;
			}

			if (charset == null)
				return bytes;
			try {
				return new String(bytes, charset);
			} catch (java.io.UnsupportedEncodingException e) {
			}
			return bytes;
		}

		/** Get the content. 
		 * @return */
		public Object getContent() {
			return content;
		}

	}

}
