package de.noiseserver;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Ein paar den Austauschprozess zwischen App und Server betreffende Konstanten
 * 
 */
public class Commons {
	// Dem Server seine URL fr die App
	//public static final String SERVER_URL = "http://128.176.171.130:8080/NoiseServerServlets/AppServlet";
	 public static final String SERVER_URL = "http://giv-noismappin1.uni-muenster.de:8080/NoiseServerServlets/AppServlet";
	// public static final String SERVER_URL =
	// "http://192.168.2.100:8080/NoiseServerServlets/AppServlet";

	public final static String NODE_SELFDESCRIPTION = "Selfdescription";
	public final static String NODE_REQUEST = "Request";
	public final static String NODE_REQUESTS_WRAPPER = "Requests";
	public static final String NODE_RESPONSE = "Response";
	public static final String NODE_RESPONSES_WRAPPER = "Responses";
	public final static String ATTR_REQUEST_TYPE = "type";

	// Quittierung
	public static final String NODE_SUCCESS = "Success";
	public static final String NODE_ERROR = "Error";
	public static final String NODE_TRUE = "True";
	public static final String NODE_FALSE = "False";
	public static final String ERROR_NOT_ALLOWED = "not_allowed";
	public static final String ERROR_DATA_SOURCE_INCAPABLE = "source_incapable";
	public static final String ERROR_UNKNOWN = "unknown";
	public static final String ERROR_TOO_MANY_REQUESTS = "too_many_requests";

	// Measures
	public final static String REQUEST_TYPE_ADDMEASURES = "AddMeasures";
	public static final String REQUEST_TYPE_GETMEASURES = "GetMeasures";
	public final static String NODE_MEASURE = "Measure";
	public static final String NODE_MEASURESERIES = "MeasureSeries";
	public final static String NODE_MEASURES_WRAPPER = "Measures";
	public static final String ERROR_ALREADY_UPLOADED = "already_uploaded";
	public static final String ERROR_MEASURE_REJECTED = "measure_rejected";

	public enum OrderAttr {
		// Einschrnkung: Mssen grogeschrieben werden
		NOISE, TIME, SERVERID, TYPE, NONE, DISTANCE
	};

	public enum OrderDir {
		ASC, DESC
	};

	public enum DataSourceIdent {
		NOISEDROID, NOISETUBE
	};

	// Login
	public static final String REQUEST_TYPE_LOGIN = "Login";
	public static final String ERROR_LOGGED_IN = "logged_in";
	public static final String ERROR_WRONG_DATA = "wrong_data";

	// Logout
	public static final String REQUEST_TYPE_LOGOUT = "Logout";

	// Register
	public static final String REQUEST_TYPE_REGISTER = "Register";
	public static final String ERROR_INVALID_USERNAME = "invalid_username";
	public static final String ERROR_INVALID_EMAIL = "invalid_email";
	public static final String ERROR_INVALID_PASSWORD = "invalid_password";

	public static final String RESET_PASSWORD = "reset_password";
	public static final String REQUEST_TYPE_RESET_PASSWORD = "request_type_reset_password";
	public static final String REQUEST_TYPE_DELETE_USER = "delete_user";

	// UpdateSeries
	public static final String REQUEST_TYPE_UPDATESERIES = "UpdateSeries";
	public static final String ERROR_SERIES_NOT_FOUND = "series_not_found";

	// HasMeasures
	public static final String REQUEST_TYPE_HASMEASURES = "HasMeasures";

	public static String md5(String val) {
		try {
			// Nach "Java EE 5 Development using GlassFish Application Server"
			MessageDigest messageDigest = MessageDigest.getInstance("MD5");
			messageDigest.reset();
			byte[] bs = messageDigest.digest(val.getBytes());
			StringBuilder stringBuilder = new StringBuilder();
			// hex encode the digest
			for (int i = 0; i < bs.length; i++) {
				String hexVal = Integer.toHexString(0xFF & bs[i]);
				if (hexVal.length() == 1) {
					stringBuilder.append("0");
				}
				stringBuilder.append(hexVal);
			}
			return stringBuilder.toString();
		} catch (NoSuchAlgorithmException e) {
			return null;
		}
	}

}
