package de.noiseserver.dto;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlTransient;

import org.postgis.Geometry;
import org.postgis.Point;

@XmlAccessorType(XmlAccessType.PROPERTY)
public class LocationDto {
	private String provider;
	private Point location;
	private Double accuracy;

	@XmlAttribute
	public Double getAccuracy() {
		return accuracy;
	}

	public void setAccuracy(Double accuracy) {
		this.accuracy = accuracy;
	}

	@XmlAttribute
	public double getLongitude() {
		if (location != null) {
			return location.getX();
		} else {
			return 0;
		}
	}

	public void setLongitude(double longitude) {
		if (location == null) {
			location = new Point();
			location.setSrid(4326);
		}
		location.setX(longitude);
	}

	@XmlAttribute
	public double getLatitude() {
		if (location != null) {
			return location.getY();
		} else {
			return 0;
		}
	}

	public void setLatitude(double latitude) {
		if (location == null) {
			location = new Point();
			location.setSrid(4326);
		}
		location.setY(latitude);
	}

	@XmlTransient
	public Point getLocation() {
		return location;
	}

	public void setLocation(Point location) {
		this.location = location;
		// if (location != null) {
		// Point point = new Point(location.x, location.y);
		// point.setSrid(location.srid);
		// this.location = point;
		// } else {
		// this.location = null;
		// }
	}

	@XmlAttribute
	public String getProvider() {
		return provider;
	}

	public void setProvider(String provider) {
		this.provider = provider;
	}
}