package de.noiseserver.dto;

import java.util.Calendar;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

import org.eclipse.persistence.oxm.annotations.XmlPath;

@XmlAccessorType(XmlAccessType.PROPERTY)
@XmlRootElement(name = "MeasureSeries")
public class MeasureSeriesDto implements AbstractMeasureDto {

	private Integer seriesid;
	private List<String> tags;
	private String title;
	private String description;
	private Calendar time;
	private Set<MeasureSingleDto> measures = new HashSet<MeasureSingleDto>();

	private UserDto uploader;

	@XmlElement(name = "Description")
	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@XmlElement(name = "Measure")
	public Set<MeasureSingleDto> getMeasures() {
		return measures;
	}

	public void setMeasures(Set<MeasureSingleDto> measures) {
		this.measures = measures;
	}

	public void addMeasure(MeasureSingleDto mDto) {
		measures.add(mDto);
	}

	@XmlAttribute(name = "id")
	public Integer getSeriesId() {
		return seriesid;
	}

	public void setSeriesId(Integer seriesid) {
		this.seriesid = seriesid;
	}

	@XmlElementWrapper(name = "Tags")
	@XmlElement(name = "Tag")
	public List<String> getTags() {
		return tags;
	}

	public void setTags(List<String> tags) {
		this.tags = tags;
	}

	@XmlPath("Time/@value")
	public Calendar getTime() {
		return time;
	}

	public void setTime(Calendar time) {
		this.time = time;
	}

	@XmlPath("Title/@value")
	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	@XmlTransient
	public UserDto getUploader() {
		return uploader;
	}

	public void setUploader(UserDto uploader) {
		this.uploader = uploader;
	}

	@Override
	public String toString() {
		String result = "Id " + seriesid + "\nTitel " + title;
		result += "\nTeilmessungen";
		for(MeasureSingleDto mDto : measures) {
			result += " "+mDto.getMeasureId();
		}
		return result;
	}

	public void removeMeasure(MeasureSingleDto mDto) {
		measures.remove(mDto);
	}
}
