package de.noiseserver.dto;

import java.util.Calendar;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

import org.eclipse.persistence.oxm.annotations.XmlPath;

@XmlAccessorType(XmlAccessType.PROPERTY)
@XmlRootElement(name = "Measure")
public class MeasureSingleDto implements AbstractMeasureDto {
	private Integer measureId;
	private double noise;
	private double moral;
	private String type;
	private Calendar time;
	private int moralConfVersion;
	private int measureConfVersion;

	private LocationDto locationMeasure;
	private LocationDto locationSource;

	private String device;
	private String description;
	private double distance;
	private double rating;
	private List<String> tags;

	private Integer measureSeriesId;

	 private UserDto uploader;

	@XmlAttribute(name = "id")
	public Integer getMeasureId() {
		return measureId;
	}

	public void setMeasureId(Integer measureid) {
		this.measureId = measureid;
	}

	@XmlPath("NoiseMeasure/@value")
	public double getNoise() {
		return noise;
	}

	public void setNoise(double noise) {
		this.noise = noise;
	}

	@XmlPath("Moral/@value")
	public double getMoral() {
		return moral;
	}

	public void setMoral(double moral) {
		this.moral = moral;
	}

	@XmlAttribute(name = "type")
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	@XmlPath("Time/@value")
	public Calendar getTime() {
		return time;
	}

	public void setTime(Calendar time) {
		this.time = time;
	}

	@XmlTransient
	public int getMoralConfVersion() {
		return moralConfVersion;
	}

	public void setMoralConfVersion(int moralConfVersion) {
		this.moralConfVersion = moralConfVersion;
	}

	@XmlTransient
	public int getMeasureConfVersion() {
		return measureConfVersion;
	}

	public void setMeasureConfVersion(int measureConfVersion) {
		this.measureConfVersion = measureConfVersion;
	}

	@XmlElement(name = "LocationMeasure")
	public LocationDto getLocationMeasure() {
		return locationMeasure;
	}

	public void setLocationMeasure(LocationDto locationMeasure) {
		this.locationMeasure = locationMeasure;
	}

	@XmlElement(name = "LocationSource")
	public LocationDto getLocationSource() {
		return locationSource;
	}

	public void setLocationSource(LocationDto locationSource) {
		this.locationSource = locationSource;
	}

	@XmlTransient
	public String getDevice() {
		return device;
	}

	public void setDevice(String device) {
		this.device = device;
	}

	@XmlElement(name = "Description")
	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@XmlPath("Distance/@value")
	public double getDistance() {
		return distance;
	}

	public void setDistance(double distance) {
		this.distance = distance;
	}

	@XmlPath("Rating/@value")
	public double getRating() {
		return rating;
	}

	public void setRating(double rating) {
		this.rating = rating;
	}

	@XmlPath("Tags/Tag/@value")
	public List<String> getTags() {
		return tags;
	}

	public void setTags(List<String> tags) {
		this.tags = tags;
	}

	@XmlTransient
	public Integer getMeasureSeriesId() {
		return measureSeriesId;
	}

	public void setMeasureSeriesId(Integer measureSeriesId) {
		this.measureSeriesId = measureSeriesId;
	}
	
	@XmlTransient
	public UserDto getUploader() {
		return uploader;
	}
	
	public void setUploader(UserDto uploader) {
		this.uploader = uploader;
	}
}
