package de.noiseserver.service;

import java.util.List;

import de.noiseserver.dto.MeasureSingleDto;

public interface DataSource {
	
	public class NotSupportedException extends Exception {

		private static final long serialVersionUID = 1L;

		public NotSupportedException(String msg) {
			super(msg);
		}

		public NotSupportedException() {
			super();
		}
	}
	
	public List<MeasureSingleDto> getMeasuresByFilter(FilterRemote filter,
			FilterPagingRemote paging, FilterSortingRemote sorting) throws NotSupportedException;

	public boolean hasMeasuresByFilter(FilterRemote filter) throws NotSupportedException;
	
	public Long getMeasuresTotalCountByFilter(FilterRemote filter) throws NotSupportedException;

}
