package de.noiseserver.service;

import java.util.List;

import javax.ejb.Local;
import javax.persistence.EntityNotFoundException;

import de.noiseserver.dto.MeasureSeriesDto;
import de.noiseserver.dto.MeasureSingleDto;
import de.noiseserver.dto.UserDto;

@Local
public interface MeasureBeanRemote extends DataSource {

	public class NotFoundException extends Exception {

		private static final long serialVersionUID = 1L;

		public NotFoundException(String msg) {
			super(msg);
		}

		public NotFoundException() {
			super();
		}
	}

	public MeasureSingleDto getMeasureById(int id) throws NotFoundException;

	public List<MeasureSingleDto> getMeasures();

	public List<MeasureSingleDto> getMeasuresByUsername(String user)
			throws NotFoundException;

	public void deleteMeasure(int id) throws NotFoundException;

	public MeasureSingleDto storeMeasure(MeasureSingleDto mDto)
			throws EntityNotFoundException;

	public long getMeasureCount();

	public MeasureSeriesDto storeMeasureSeries(MeasureSeriesDto sDto);

	public UserDto getUserById(Integer userid) throws NotFoundException;

	public UserDto getUserByUsername(String username) throws NotFoundException;

	public MeasureSeriesDto getMeasureSeriesById(int seriesId)
			throws NotFoundException;

	public UserDto storeUser(UserDto uDto);

	public boolean hasUserByUsername(String username);

	public List<MeasureSingleDto> getMeasuresByUserId(Integer userId)
			throws NotFoundException;

}
