package de.noiseserver.servlet;

import java.io.BufferedReader;
import java.io.IOException;

import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import de.noiseserver.service.MeasureBeanRemote;
import de.noiseserver.servlet.app.requestprocessors.RequestProcessor;

/**
 * Servlet implementation class AppServlet
 */
@WebServlet("/AppServlet")
public class AppServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	@EJB
	private MeasureBeanRemote measureBean;

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		BufferedReader reader = req.getReader();

		// Suche des XML-Prologs
		reader.mark(0);
		String line = null;
		while ((line = reader.readLine()) != null) {
			if (line.startsWith("<?xml")) {
				reader.reset();
				break;
			} else {
				reader.mark(0);
			}
		}

		// Eigentliche Verarbeitung
		try {
			RequestProcessor requestProcessor = new RequestProcessor();
			requestProcessor.processRequest(measureBean, req, resp);

		} catch (Exception e) {
			resp.sendError(500);
			line = null;
			reader.reset();
			StringBuilder builder = new StringBuilder();
			builder.append("Error processing the following request:\n");
			while ((line = reader.readLine()) != null) {
				builder.append(line+"\n");
			}
			System.out.print(builder);
			e.printStackTrace();
		}

	}
}
