package de.noiseserver.servlet.app.requestprocessors;

import javax.mail.MessagingException;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.stream.XMLStreamReader;

import org.w3c.dom.Element;

import de.noiseserver.Commons;
import de.noiseserver.servlet.AuthException;
import de.noiseserver.servlet.app.xmltemplates.XMLDeleteUserTemplate;
import de.noiseserver.servlet.app.xmltemplates.XMLLoginTemplate;
import de.noiseserver.servlet.app.xmltemplates.XMLPasswordResetTemplate;

public class DeleteUserProcessor extends RequestProcessingElement {

	@Override
	public String getRequestType() {
		return Commons.REQUEST_TYPE_DELETE_USER;
	}

	@Override
	protected void processRequest(XMLStreamReader reader, Element responseNode) {
		try {
			JAXBContext context = JAXBContext
					.newInstance(XMLDeleteUserTemplate.class);
			Unmarshaller unmarshaller = context.createUnmarshaller();
		 XMLDeleteUserTemplate xmlTemplate = (XMLDeleteUserTemplate) unmarshaller
					.unmarshal(reader);
			requestProcessor.deleteUser(xmlTemplate.username,
					xmlTemplate.password);
			Element successElement = responseNode.getOwnerDocument()
					.createElement(Commons.NODE_SUCCESS);
			responseNode.appendChild(successElement);

		} catch (JAXBException e) {
			error(responseNode);
		} catch (AuthException e) {
			error(responseNode);
		} 
	}

}
