package de.noiseserver.servlet.app.requestprocessors;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.stream.XMLStreamReader;

import org.w3c.dom.Element;

import de.noiseserver.Commons;
import de.noiseserver.servlet.AuthException;
import de.noiseserver.servlet.app.xmltemplates.XMLLoginTemplate;

public class LoginProcessor extends RequestProcessingElement {

	@Override
	public String getRequestType() {
		return Commons.REQUEST_TYPE_LOGIN;
	}

	@Override
	protected void processRequest(XMLStreamReader reader, Element responseNode) {
		try {
			JAXBContext context = JAXBContext
					.newInstance(XMLLoginTemplate.class);
			Unmarshaller unmarshaller = context.createUnmarshaller();
			XMLLoginTemplate xmlTemplate = (XMLLoginTemplate) unmarshaller
					.unmarshal(reader);

			if (requestProcessor.isLoggedIn()) {
				error(responseNode, Commons.ERROR_LOGGED_IN);
				return;
			}
			requestProcessor.login(xmlTemplate.username,
					xmlTemplate.passwordMD5);
			Element successElement = responseNode.getOwnerDocument()
					.createElement(Commons.NODE_SUCCESS);
			responseNode.appendChild(successElement);

		} catch (JAXBException e) {
			error(responseNode);
		} catch (AuthException e) {
			error(responseNode, Commons.ERROR_WRONG_DATA);
		}
	}

}
