package de.noiseserver.servlet.app.requestprocessors;

import javax.mail.MessagingException;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.stream.XMLStreamReader;

import org.w3c.dom.Element;

import de.noiseserver.Commons;
import de.noiseserver.servlet.AuthException;
import de.noiseserver.servlet.app.xmltemplates.XMLLoginTemplate;
import de.noiseserver.servlet.app.xmltemplates.XMLPasswordResetTemplate;

public class PasswordResetProcessor extends RequestProcessingElement {

	@Override
	public String getRequestType() {
		return Commons.REQUEST_TYPE_RESET_PASSWORD;
	}

	@Override
	protected void processRequest(XMLStreamReader reader, Element responseNode) {
		try {
			JAXBContext context = JAXBContext
					.newInstance(XMLPasswordResetTemplate.class);
			Unmarshaller unmarshaller = context.createUnmarshaller();
			XMLPasswordResetTemplate xmlTemplate = (XMLPasswordResetTemplate) unmarshaller
					.unmarshal(reader);
			requestProcessor.resetPassword(xmlTemplate.username,
					xmlTemplate.email);
			Element successElement = responseNode.getOwnerDocument()
					.createElement(Commons.NODE_SUCCESS);
			responseNode.appendChild(successElement);

		} catch (JAXBException e) {
			error(responseNode);
		} catch (AuthException e) {
			error(responseNode);
		} catch (MessagingException e) {
			error(responseNode);
		}
	}

}
