package de.noiseserver.servlet.app.requestprocessors;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import javax.xml.stream.XMLStreamReader;

import org.w3c.dom.Element;

import de.noiseserver.Commons;
import de.noiseserver.dto.GroupDto;
import de.noiseserver.dto.UserDto;
import de.noiseserver.servlet.AuthException;
import de.noiseserver.servlet.NoiseServer;
import de.noiseserver.servlet.app.xmltemplates.XMLRegisterTemplate;

public class RegisterProcessor extends RequestProcessingElement {

	@Override
	public String getRequestType() {
		return Commons.REQUEST_TYPE_REGISTER;
	}

	@Override
	protected void processRequest(XMLStreamReader reader, Element responseNode) {
		try {
			JAXBContext context = JAXBContext
					.newInstance(XMLRegisterTemplate.class);
			Unmarshaller unmarshaller = context.createUnmarshaller();
			XMLRegisterTemplate xmlTemplate = (XMLRegisterTemplate) unmarshaller
					.unmarshal(reader);

			try {
				requestProcessor.register(xmlTemplate.username,
						xmlTemplate.email, xmlTemplate.passwordMD5);
				Element successElement = responseNode.getOwnerDocument()
						.createElement(Commons.NODE_SUCCESS);
				responseNode.appendChild(successElement);
				if (requestProcessor.isLoggedIn()) {
					requestProcessor.logout();
				}
			} catch (AuthException e) {
				// Registrieren schlgt fehl
				error(responseNode, e.getMessage());
			}

		} catch (JAXBException e) {
			error(responseNode);
		}
	}

}
