package de.noiseserver.servlet.app.tags;

import java.io.IOException;

import javax.servlet.jsp.JspContext;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.JspFragment;
import javax.servlet.jsp.tagext.SimpleTagSupport;

import de.noiseserver.service.MeasureBeanRemote;
import de.noiseserver.service.MeasureBeanRemote.NotFoundException;

public class CurrentUserTag extends SimpleTagSupport {

	private JspFragment hasUserFragment;
	private JspFragment noUserFragment;
	private String varnameUser;

	public void setHasuser(JspFragment hasuser) {
		this.hasUserFragment = hasuser;
	}

	public void setNouser(JspFragment nouser) {
		this.noUserFragment = nouser;
	}

	public void setVar(String var) {
		this.varnameUser = var;
	}

	public void doTag() throws JspException, IOException {
		JspContext jspContext = getJspContext();

		if (jspContext.getAttribute("measureBean") != null) {
			MeasureBeanRemote measureBean = (MeasureBeanRemote) jspContext
					.getAttribute("measureBean");
			Integer userId = (Integer) jspContext.getAttribute("userid",
					PageContext.SESSION_SCOPE);

			if (userId != null) {
				try {
					jspContext.setAttribute(varnameUser,
							measureBean.getUserById(userId));
					if (hasUserFragment != null) {
						hasUserFragment.invoke(null);
					} else {
						JspFragment body = getJspBody();
						if (body != null) {
							body.invoke(null);
						}
					}
				} catch (NotFoundException e) {
					if (noUserFragment != null) {
						noUserFragment.invoke(null);
					}
				}
			} else {
				if (noUserFragment != null) {
					noUserFragment.invoke(null);
				}
			}
		} else {
			throw new JspException("measureBean not set!");
		}
	}
}