package de.noiseserver.servlet.app.tags;

import java.io.IOException;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.JspFragment;
import javax.servlet.jsp.tagext.SimpleTagSupport;

import de.noiseserver.service.MeasureBeanRemote;

public class MeasureBeanTag extends SimpleTagSupport {

	public void doTag() throws JspException, IOException {
		if (getJspContext().getAttribute("measureBean") == null) {
			try {
				InitialContext ctx = new InitialContext();
				MeasureBeanRemote measureBean = (MeasureBeanRemote) ctx
						.lookup("java:global/NoiseServerEAR/NoiseServerEJB/MeasureBean!de.noiseserver.service.MeasureBean");
				getJspContext().setAttribute("measureBean", measureBean);
			} catch (NamingException e) {
				throw new JspException(e);
			}
		}
		
		JspFragment body = getJspBody();
		if (body != null) {
			body.invoke(null);
		}
	}
}