package de.noiseserver.servlet.app.tags;

import java.io.IOException;

import javax.servlet.jsp.JspContext;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.JspFragment;
import javax.servlet.jsp.tagext.SimpleTagSupport;

import de.noiseserver.service.MeasureBeanRemote;
import de.noiseserver.service.MeasureBeanRemote.NotFoundException;

public class MeasureTag extends SimpleTagSupport {
	private Integer id;
	private String varnameMeasure;

	public void setId(Integer id) {
		this.id = id;
	}

	public void setVar(String var) {
		this.varnameMeasure = var;
	}

	public void doTag() throws JspException, IOException {
		JspContext jspContext = getJspContext();

		if (jspContext.getAttribute("measureBean") != null) {
			MeasureBeanRemote measureBean = (MeasureBeanRemote) jspContext
					.getAttribute("measureBean");
			if (id != null) {
				try {
					jspContext.setAttribute(varnameMeasure,
							measureBean.getMeasureById(id));

					JspFragment body = getJspBody();
					if (body != null) {
						body.invoke(null);
					}
				} catch (NotFoundException e) {

				}
			}
		} else {
			throw new JspException("measureBean not set!");
		}
	}
}