package de.noiseserver.servlet.list;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import de.noiseserver.dto.LocationDto;

@XmlRootElement(name = "Measure")
@XmlAccessorType(XmlAccessType.FIELD)
public class JsonLocationTemplate {

	@XmlElement
	public Double longitude;
	@XmlElement
	public Double latitude;
	@XmlElement
	public String provider;
	@XmlElement
	public Double accuracy;

	public static JsonLocationTemplate fromDto(LocationDto lDto) {
		JsonLocationTemplate jsonLocation = new JsonLocationTemplate();
		jsonLocation.accuracy = lDto.getAccuracy();
		jsonLocation.latitude = lDto.getLatitude();
		jsonLocation.longitude = lDto.getLongitude();
		jsonLocation.provider = lDto.getProvider();
		return jsonLocation;
	}

}