package de.noiseserver.servlet.list;

import java.util.Calendar;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import de.noiseserver.dto.MeasureSingleDto;

@XmlRootElement(name = "Location")
@XmlAccessorType(XmlAccessType.FIELD)
public class JsonMeasureTemplate {

	public static JsonMeasureTemplate fromDto(MeasureSingleDto mDto) {
		JsonMeasureTemplate jsonMeasure = new JsonMeasureTemplate();
		jsonMeasure.noise = mDto.getNoise();
		jsonMeasure.serverid = mDto.getMeasureId();
		jsonMeasure.time = mDto.getTime();
		jsonMeasure.description = mDto.getDescription();
		jsonMeasure.moral = mDto.getMoral();
		jsonMeasure.type = mDto.getType();
		jsonMeasure.tags = mDto.getTags();
		jsonMeasure.locationmeasure = JsonLocationTemplate.fromDto(mDto
				.getLocationMeasure());
		return jsonMeasure;
	}

	@XmlElement
	public Integer serverid;
	@XmlElement
	public Double noise;
	@XmlElement
	public Calendar time;
	@XmlElement
	public Double moral;
	@XmlElement
	public String type;
	@XmlElement
	public String description;
	@XmlElement
	public List<String> tags;
	@XmlElement
	public JsonLocationTemplate locationmeasure;
}